#ifndef LISTVIEW_H
#define LISTVIEW_H

#include <qlistbox.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qstrlist.h>
#include <qpopmenu.h>
#include <qlined.h>
#include <qlabel.h>
#include <fcntl.h>
#include <qdialog.h>
#include "MultiListBox.h"

#ifdef FreeBSD
#include <machine/soundcard.h>
#endif
#ifdef Linux
#include <sys/soundcard.h>
#endif

#define DEVICE 0
#define MIXER "/dev/mixer"

/*
class AlbumListBoxItem : public QListBoxItem
{
protected:
        QPixmap pm;

	void paint( QPainter * );
        int height( const QListBox * ) const;
        int width( const QListBox * ) const;
        const QPixmap *pixmap() { return &pm; }

public:
	AlbumListBoxItem( const char *s, const QPixmap p )
            	: QListBoxItem(), pm(p)
		{ setText( s );}

};
*/


class AlbumItem
{
public:
	QString Singer;
	QString Publish;
	QString Picture;
	QString SingerAlbum;
	int total;

	const char *GetSinger() { return Singer;}
	const char *GetPublish() { return Publish;}
	const char *GetPicture() { return Picture;}
	const char *GetSingerAlbum() {return SingerAlbum;}
	AlbumItem() {total=0;}
	void AddSong(char *,char *);
	void AddSong(QString,QString);
	int Count() {return total;}
	const QStrList* GetSongList() {return &SongList;}
	QStrList* GetFileList() {return &FileList;}
	AlbumItem& operator=(const AlbumItem *);

protected:
	QStrList SongList;
	QStrList FileList;
};

class AlbumListBox : public MultiListBox
{
	Q_OBJECT

protected:
	int total;
	char filename[51];
	int AlbumChange;
	QPopupMenu *fun;

	void mousePressEvent(QMouseEvent *e);
	void mouseReleaseEvent(QMouseEvent *e);
	void DumpInfo();
	void DoAppendAlbum(AlbumItem *);
	void DoInsertAlbum(int,AlbumItem *);
	void mouseDoubleClickEvent(QMouseEvent *e);
public:
	QList<AlbumItem> ptr;

	AlbumListBox(QWidget* parent=0, const char* name=0);
	int Count() {return total;}
	int IsChange() { return AlbumChange;}
	int LoadFromFile();
	void Refresh();

public slots:
	void NewAlbum();
	void EditAlbum();
	void DelAlbum();
	int SaveToFile();
signals:
	void selected(AlbumItem);
};

class Mixer
{
private:
	int fd;
	const char **names;
	const char *mixer;

public:
	Mixer();
	~Mixer();
	int Get();	// -1:Fail
	int Set(int);	// 1:Succeed, -1:Fail
};

class AlbumInfoView : public QDialog
{
	Q_OBJECT

protected:
	QLineEdit *edtSinger;
	QLineEdit *edtAlbum;
	QLineEdit *edtPublish;
	QString *Picture;
	QLabel *Title;
	QListBox *FileBox;
	QListBox *SongBox;
	QLineEdit *edtFile;
	QLineEdit *edtSong;
	int index;

public:
	AlbumInfoView(AlbumItem *,int,QWidget *parent=0);
	AlbumItem GetAlbumInfo();
	int GetAlbumIndex() { return index;}
public slots:
	void FileChange(int);
	void SongChange(int);
	void SetSongName();
	void PicBrowse();
	void FileBrowse();
	void InsertSong();
	void RemoveSong();
};

#endif LISTVIEW_H
