// written by mills

#include <qtablevw.h>
#include <qwidget.h>
#include <qpixmap.h>
#include <qlist.h>

class MultiListBox;

class MultiListBoxItem
{
public:
	MultiListBoxItem(char *str) { Text = str; }
	MultiListBoxItem(QPixmap p,char *str) {Pic = p; Text = str;}
	MultiListBoxItem(MultiListBoxItem *i){
		Pic = i->Pic;
		Text = i->Text;
	} 
	setPixmap(QPixmap& p) {Pic = p;}
	int Width(MultiListBox *box);
	int Height(MultiListBox *box,int max_w);
	void Paint(QPainter *p,int w,int h,int flag=0);
	QPixmap Pic;
	QString Text;

protected:
	void MyDrawText(QPainter *p,int x,int y,int max_w);
};

class MultiListBox : public QTableView
{
	Q_OBJECT

public:
	MultiListBox(QWidget *parent=0,char *name=0,int numCols=4);
	~MultiListBox() {}
	void InsertItem(int i,MultiListBoxItem*);	// i:index from 0
	void InsertItem(int row,int col,MultiListBoxItem*);
	void AppendItem(MultiListBoxItem*);
	void DeleteItem(int i);
	void DeleteItem(int row,int col);		// row:col from (0,0)
	void ChangeItem(int,MultiListBoxItem*);
	void ChangeItem(int row,int col,MultiListBoxItem*);
	int CurrentItem() {return indexOf(curRow,curCol);}
	int CurrentRow() {return curRow;}
	int CurrentCol() {return curCol;}
	void SetAutoArrange(bool a) {isAutoArrange=a;}
	bool GetAutoArrange() { return isAutoArrange;}
	void Clear();
	int Count(){return count;}
signals:
	void highlighted(int index);
	void selected(int index);

protected:
	void paintCell(QPainter*,int row,int col);
	void mouseDoubleClickEvent(QMouseEvent *e);
	void mousePressEvent(QMouseEvent *e);
	void resizeEvent(QResizeEvent *e);
	int cellWidth(int col);
	int cellHeight(int row);
	int indexOf(int row,int col);
	int HintRow();

	bool isAutoArrange;
	int curRow;
	int curCol;
	int oldRow;
	int oldCol;
	int count;
	int fixedColWidth;
	QList<MultiListBoxItem> ItemList;
};

