#include <qdir.h>
#include "qktstreelist.h"
#include <qlistbox.h>
#include <qstring.h>
#include <qpushbt.h>
#include <qlined.h>
#include <qlabel.h>
#include <qlayout.h>

class DiskBrowser : public QWidget
{
	Q_OBJECT
  public:
    DiskBrowser(QWidget *parent = 0, 
		const char *filter = "*",
		const char *name = 0,
		WFlags f = 0);
    ~DiskBrowser();
    uint fileCount();
    const char* getFileName(int);	//add by mills
    const char* getSelectedFileName();  //add by mills
    const QStrList* getFileList();	//add by mills
  signals:
    void selectedFile(int);		//add by mills

  private slots:
    void dirExpanded(int);
    void dirHighlighted(int);
    void dirSelected(int);
    void exportSelectedFile(int);	//add by mills
    void setFilter();			//add by mills

  private:
    void advanceReadDirectories(int treeIndex);
    void initializeTree();
    QktsTreeList *dirTree;
    QListBox *fileList;
    QPixmap *openPixmap;
    QPixmap *closedPixmap;
    QLabel *lblPath;			//add by mills
    QLabel *lblFilt;			//add by mills
    QLineEdit *edtFilt;			//add by mills
};
