#include <qmsgbox.h>
#include <qlayout.h>
#include <qpushbt.h>
#include <qlined.h>
#include <qtooltip.h>
#include "filebrowse.h"

FileBrowseView::FileBrowseView(QWidget *parent=0,char *filter="*.mp3",char *name=0)
		:QDialog(parent,"browse",TRUE)
{
	setCaption("Browse Files");

	QGridLayout *topLayout = new QGridLayout(this,11,7,5);

	QPushButton *btn;

	btn = new QPushButton("=>",this);
	QToolTip::add( btn, "insert one");
	connect(btn,SIGNAL(clicked()),this,SLOT(Insert()));
	topLayout->addWidget(btn,3,4);
	btn = new QPushButton("<=",this);
	QToolTip::add( btn, "delete one");
	connect(btn,SIGNAL(clicked()),this,SLOT(Remove()));
	topLayout->addWidget(btn,4,4);
	btn = new QPushButton("==>",this);
	QToolTip::add( btn, "insert all");
	connect(btn,SIGNAL(clicked()),this,SLOT(InsertAll()));
	topLayout->addWidget(btn,5,4);
	btn = new QPushButton("<==",this);
	QToolTip::add( btn, "clear all");
	connect(btn,SIGNAL(clicked()),this,SLOT(Clear()));
	topLayout->addWidget(btn,6,4);

	QLabel *b = new QLabel("Selected Files:",this);
	topLayout->addMultiCellWidget(b,0,0,5,6);

	db = new DiskBrowser(this,filter);
	topLayout->addMultiCellWidget(db,0,9,0,3);
	connect(db,SIGNAL(selectedFile(int)),this,SLOT(Insert(int)));

        SelectFile = new QListBox(this);
        connect(SelectFile,SIGNAL(selected(int)),this,SLOT(Remove()));
        topLayout->addMultiCellWidget(SelectFile,1,8,5,6);

	btn = new QPushButton("OK",this);
	connect(btn,SIGNAL(clicked()),this,SLOT(accept()));
	topLayout->addWidget(btn,10,2);
	btn = new QPushButton("Cancel",this);
	connect(btn,SIGNAL(clicked()),this,SLOT(reject()));
	topLayout->addWidget(btn,10,4);

	topLayout->activate();
	resize(600,500);
}

void FileBrowseView::Insert(int i)
{
	if (db->getFileName(i) != NULL)
		SelectFile->insertItem(db->getFileName(i));
}


void FileBrowseView::Insert()
{
	if (db->getSelectedFileName() != NULL)
		SelectFile->insertItem(db->getSelectedFileName());
}


void FileBrowseView::Remove()
{
	if (SelectFile->currentItem() > -1)
		SelectFile->removeItem(SelectFile->currentItem());
}


void FileBrowseView::InsertAll()
{
	SelectFile->insertStrList(db->getFileList());
}


void FileBrowseView::Clear()
{
	SelectFile->clear();
}


QStrList FileBrowseView::GetSongList()
{
	int i;
	QStrList a;
	if (SelectFile->count()>0){
		for (i=0;i<SelectFile->count();i++)
			a.append(SelectFile->text(i));
		return a;
	}
	else
		return NULL;
}

MyOpenFile::MyOpenFile(QWidget *parent=0,char *name=0)
	:QDialog(parent,"open",TRUE)
{
}

QString MyOpenFile::getOpenFileName(QWidget *parent=0,char *filter="*.*")
{
	QDialog *dg = new QDialog(parent,"open",TRUE);
	dg->setCaption("Open File");

	QGridLayout *topLayout = new QGridLayout(dg,10,4,5);
	DiskBrowser *db = new DiskBrowser(dg,filter);
	topLayout->addMultiCellWidget(db,0,8,0,3);

	QPushButton *btnSubmit = new QPushButton("OK",dg);
	btnSubmit->resize(60,30);
	connect(btnSubmit,SIGNAL(clicked()),dg,SLOT(accept()));
	topLayout->addWidget(btnSubmit,9,2);

	QPushButton *btnCancel = new QPushButton("Cancel",dg);
	btnCancel->resize(60,30);
	connect(btnCancel,SIGNAL(clicked()),dg,SLOT(reject()));
	topLayout->addWidget(btnCancel,9,3);

	topLayout->activate();

	QString result;
	if (dg->exec() == QDialog::Accepted )
		result = db->getSelectedFileName();
	else
		result = NULL;

	delete dg;
	return result;
}
