#ifndef PLAYER_H
#define PLAYER_H

#include <qwidget.h>
#include <qlistbox.h>
#include <qlabel.h>
#include <qpopmenu.h>
#include "ListView.h"
#include "clock.h"

class PlayerWidget : public QWidget
{
	Q_OBJECT
public:
	PlayerWidget( QWidget *parent = 0, const char *name = 0 );
	~PlayerWidget();
	QLabel *edtName;
	QLabel *edtAlbum;
	QLabel *edtPub;

public slots:
	void AutoPlay();
	void RepeatPlay();
//	void RandomPlay();
	void GoFirst();
	void GoPrevious();
	void GoPlay();
	void GoStop();
	void GoNext();
	void GoLast();
	void AlbumChange(AlbumItem);
	void VolumeChange(int);
	void AllView();
	void NormalView();
	void SmallView();
	void Usage();
	void About();
	void OpenFiles();
	void closehelp();
protected:
	QWidget *help;
	QListBox *SongBox;
	QListBox *LocBox;
	AlbumListBox *list;
	QPopupMenu* options;
	DigitalClock *dclock;
	QLabel *song;
	Mixer *MyMixer;
	bool isAutoPlay;
	bool isRepeat;
//	bool isRandom;
	int AutoPlayID,RepeatID,RandomID;
	void timerEvent( QTimerEvent * );
	void resizeEvent(QResizeEvent *e);
	
	static int mp3_pid;
	static int isContinue;
	static int isStop;
	static int isPause;
	static int status;
	static void ChildEnd(int);
	static int CurrPlaySong;
};

#endif PLAYER_H
